/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// Price Provides all amounts (tax included, duty free, tax rate), used currency and percentage to apply for Price Alteration.
type Price struct {
	// Percentage to apply for ProdOfferPriceAlteration
	Percentage *float32 `json:"percentage,omitempty"`
	// Tax rate
	TaxRate *float32 `json:"taxRate,omitempty"`
	DutyFreeAmount *Money `json:"dutyFreeAmount,omitempty"`
	TaxIncludedAmount *Money `json:"taxIncludedAmount,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
}

// NewPrice instantiates a new Price object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPrice() *Price {
	this := Price{}
	return &this
}

// NewPriceWithDefaults instantiates a new Price object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPriceWithDefaults() *Price {
	this := Price{}
	return &this
}

// GetPercentage returns the Percentage field value if set, zero value otherwise.
func (o *Price) GetPercentage() float32 {
	if o == nil || o.Percentage == nil {
		var ret float32
		return ret
	}
	return *o.Percentage
}

// GetPercentageOk returns a tuple with the Percentage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Price) GetPercentageOk() (*float32, bool) {
	if o == nil || o.Percentage == nil {
		return nil, false
	}
	return o.Percentage, true
}

// HasPercentage returns a boolean if a field has been set.
func (o *Price) HasPercentage() bool {
	if o != nil && o.Percentage != nil {
		return true
	}

	return false
}

// SetPercentage gets a reference to the given float32 and assigns it to the Percentage field.
func (o *Price) SetPercentage(v float32) {
	o.Percentage = &v
}

// GetTaxRate returns the TaxRate field value if set, zero value otherwise.
func (o *Price) GetTaxRate() float32 {
	if o == nil || o.TaxRate == nil {
		var ret float32
		return ret
	}
	return *o.TaxRate
}

// GetTaxRateOk returns a tuple with the TaxRate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Price) GetTaxRateOk() (*float32, bool) {
	if o == nil || o.TaxRate == nil {
		return nil, false
	}
	return o.TaxRate, true
}

// HasTaxRate returns a boolean if a field has been set.
func (o *Price) HasTaxRate() bool {
	if o != nil && o.TaxRate != nil {
		return true
	}

	return false
}

// SetTaxRate gets a reference to the given float32 and assigns it to the TaxRate field.
func (o *Price) SetTaxRate(v float32) {
	o.TaxRate = &v
}

// GetDutyFreeAmount returns the DutyFreeAmount field value if set, zero value otherwise.
func (o *Price) GetDutyFreeAmount() Money {
	if o == nil || o.DutyFreeAmount == nil {
		var ret Money
		return ret
	}
	return *o.DutyFreeAmount
}

// GetDutyFreeAmountOk returns a tuple with the DutyFreeAmount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Price) GetDutyFreeAmountOk() (*Money, bool) {
	if o == nil || o.DutyFreeAmount == nil {
		return nil, false
	}
	return o.DutyFreeAmount, true
}

// HasDutyFreeAmount returns a boolean if a field has been set.
func (o *Price) HasDutyFreeAmount() bool {
	if o != nil && o.DutyFreeAmount != nil {
		return true
	}

	return false
}

// SetDutyFreeAmount gets a reference to the given Money and assigns it to the DutyFreeAmount field.
func (o *Price) SetDutyFreeAmount(v Money) {
	o.DutyFreeAmount = &v
}

// GetTaxIncludedAmount returns the TaxIncludedAmount field value if set, zero value otherwise.
func (o *Price) GetTaxIncludedAmount() Money {
	if o == nil || o.TaxIncludedAmount == nil {
		var ret Money
		return ret
	}
	return *o.TaxIncludedAmount
}

// GetTaxIncludedAmountOk returns a tuple with the TaxIncludedAmount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Price) GetTaxIncludedAmountOk() (*Money, bool) {
	if o == nil || o.TaxIncludedAmount == nil {
		return nil, false
	}
	return o.TaxIncludedAmount, true
}

// HasTaxIncludedAmount returns a boolean if a field has been set.
func (o *Price) HasTaxIncludedAmount() bool {
	if o != nil && o.TaxIncludedAmount != nil {
		return true
	}

	return false
}

// SetTaxIncludedAmount gets a reference to the given Money and assigns it to the TaxIncludedAmount field.
func (o *Price) SetTaxIncludedAmount(v Money) {
	o.TaxIncludedAmount = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *Price) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Price) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *Price) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *Price) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *Price) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Price) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *Price) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *Price) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *Price) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Price) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *Price) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *Price) SetType(v string) {
	o.Type = &v
}

func (o Price) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Percentage != nil {
		toSerialize["percentage"] = o.Percentage
	}
	if o.TaxRate != nil {
		toSerialize["taxRate"] = o.TaxRate
	}
	if o.DutyFreeAmount != nil {
		toSerialize["dutyFreeAmount"] = o.DutyFreeAmount
	}
	if o.TaxIncludedAmount != nil {
		toSerialize["taxIncludedAmount"] = o.TaxIncludedAmount
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullablePrice struct {
	value *Price
	isSet bool
}

func (v NullablePrice) Get() *Price {
	return v.value
}

func (v *NullablePrice) Set(val *Price) {
	v.value = val
	v.isSet = true
}

func (v NullablePrice) IsSet() bool {
	return v.isSet
}

func (v *NullablePrice) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePrice(val *Price) *NullablePrice {
	return &NullablePrice{value: val, isSet: true}
}

func (v NullablePrice) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePrice) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


